SwypeDetector = Core.class()

SwypeDetector.MinDistance = 100
SwypeDetector.MinVelocity = 100
 
function SwypeDetector:init(parent, onFlingX, onFlingY, onScroll)
	self.parent = parent
	parent:addEventListener(Event.TOUCHES_BEGIN, self.touchesBegin, self);
	parent:addEventListener(Event.TOUCHES_MOVE, self.touchesMove, self);
	parent:addEventListener(Event.TOUCHES_END, self.touchesEnd, self);
	self.onFlingX = onFlingX
	self.onFlingY = onFlingY
	self.onScroll = onScroll
end
 
function SwypeDetector:swipeTimer(event)
	self.time = self.time + .1;
end
 
function SwypeDetector:touchesBegin(event)
	if self.timer then
		self.timer:stop()
	end
	self.time = 0;
	self.canSwipe = true;
	self.startX = event.touch.x;
	self.startY = event.touch.y;
	self.lastX = event.touch.x;
	self.lastY = event.touch.y;
 
	-- add timer
	local timer = Timer.new(100, 10);
	self.timer = timer;
	timer:addEventListener(Event.TIMER, self.swipeTimer, self);
	timer:addEventListener(Event.TIMER_COMPLETE, function() self.timer:stop() self.canSwipe = false end);
	timer:start();
end
 
function SwypeDetector:touchesMove(event)
	self:doScroll(event)
	self.lastX = event.touch.x
end
 
function SwypeDetector:doFlingX(event)
	if onFlingX ~= nil then
		self.onFlingX(self.parent, (event.touch.x - self.startX) / self.time)
	end
end
 
function SwypeDetector:doFlingY(event)
	if onFlingY ~= nil then
		self.onFlingY(self.parent, (event.touch.Y - self.startY) / self.time)
	end
end
 
function SwypeDetector:doScroll(event)
	if onScroll ~= nil then
		self.onFlingY(self.parent, self.lastX - event.touch.x, self.startY - event.touch.y)
	end
end
 
function SwypeDetector:checkFling(p1, p2)
	if self.time == 0 then return false end
	if math.abs(p1 - p2) > SwypeDetector.MinDistance and math.abs(p1 - p2) / self.time > SwypeDetector.MinVelocity then
		return true
	else
		return false
	end
end
 
function SwypeDetector:touchesEnd(event)
 	if self.canSwipe then
		if self:checkFling(event.touch.x , self.startX) then
			self:doFlingX(event)
		elseif self:checkFling(event.touch.y , self.startY) then
			self:doFlingY(event)
		else
			self:doScroll(event)
		end
	end
	self.timer:stop()
end